/*	Proiect PM: UTP Tester
 *
 */
#include <util/delay.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include "lcd.h"

// vector care va contine ordinea pinilor
int cable[8] = 		{0, 0, 0, 0, 0, 0, 0, 0};

// vectori de referinta pentru comparare
int straight[8] = 	{1, 2, 3, 4, 5, 6, 7, 8};
int cross[8] = 		{1, 2, 7, 4, 5, 8, 3, 6};
int roll[8] = 		{8, 7, 6, 5, 4, 3, 2, 1};


int main() {

	// initializari
	LCD_init();
	DDRD = 0xFF;
	DDRA = 0xFF;
	DDRB = 0x00;
	while (1){
		LCD_writeInstr(LCD_INSTR_clearDisplay);
		LCD_print("Checking cable");
		DDRD = 0xFF;
		DDRA = 0xFF;
		DDRB = 0x00;
		int i = 0;
		int j = 0;
		
		for (i = 0; i < 8; i ++){
			if (i < 4){
				PORTD = 1 << 6;
				PORTA = 1 << i;
				}
			else if (i > 3 && i < 7){
				PORTA = 1 << 5;
				PORTD = 1 << (i - 4);
			}
			else if (i == 7)
				PORTD = 1 << 5;
				
			if (PINB == 0x00)
				cable[i] = 0;
			else
				for (j = 0; j < 8; j ++)
					if (bit_is_set(PINB, j)){
						cable[i] = j + 1;
						break;	
					}
			
				
				
			_delay_ms(200);
			if (i == 7)
				PORTD = 1 << 6;
		
		}
		if (memcmp(cable, straight, sizeof(cable)) == 0){
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("Straight cable");
		}
		else if (memcmp(cable, cross, sizeof(cable)) == 0){
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("Cross cable");
		}
		else if (memcmp(cable, roll, sizeof(cable)) == 0){
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("Rollover cable");
		}
		else{
			LCD_writeInstr(LCD_INSTR_clearDisplay);
			LCD_print("Bad cable");
		}
		_delay_ms(3000);
		
		
	}

	return 0;
}
